Incorrect evaluation of Rule-Base features
Status: Closed

Priority: Normal

Assignee:

Category: Vectors

Affected QGIS version:2.4.0 Regression?: No

Operating System: Windows 8.1 Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 19582
Description

The evaluation of complex Rule-Based symbols is not evaluating correctly

Add a vector layer to a map containing point data, and several fields. In the Layer Properties dialogue, under Style, change to
Rule-Based. Add four rules of the form

fld_a ='AB' AND fld_b > 3 AND fld_c > 2009

fld_a ='CB' AND fld_b > 3 ADN fld_c > 2009

fld_c <= 2009 AND flo_B > 3

fid_b<=3

Displaying the result or counting the features results in too many of symbol fld_b <= 3. No duplicates are counted.
However, if the data is added as three layers, and the query builder under the General tab is used to build expressions for fields fld_b and
fld_c, the correct result is obtained

History

#1 - 2014-09-29 03:46 AM - Harrissou Santanna

Hi Harry,

can you join a sample data to help us try your issue, please?

#2 - 2014-09-29 04:12 AM - Harry Clarke

- File Transect_site_view.zip added

Shapefile of the table view that created the problem

#3 - 2014-09-29 07:15 PM - Leyan Ouyang

The shapefile field names are not the same so | am not sure exactly what you are doing, but be careful about data type, your "count” attribute is a string.

However, | tried rules equivalent to what you wrote and did not get any issue, could you take a screenshot with the rules and the wrong end result?

#4 - 2014-09-30 01:35 AM - Harry Clarke
- File QRIS-issue-11286.jpg added

The count field is a bigint, which is the type created by PostgreSQL when using the Count function. As requested screenshot showing the wrong counts for
the rules used, and also view from PGAdmin showing the data type for the field count

#5 - 2017-05-01 01:08 AM - Giovanni Manghi
- Regression? set to No
- Easy fix? set to No

#6 - 2018-08-10 12:23 PM - Harry Clarke

- Status changed from Open to Closed

This has been checked in QGIS 3.2.1 and issue seems have been resolved

#7 - 2018-08-12 02:36 PM - Giovanni Manghi
- Resolution set to fixed/implemented
- Description updated

Files

Transect_site_view.zip 6.28 KB 2014-09-29 Harry Clarke

QRIS-issue-11286.jpg 132 KB 2014-09-29 Harry Clarke
